<?php

require_once('./setup_admin.php');

$conf_file = GT_BLOG_CONF_FILE;
$template = 'edit_blog.tpl';

$request = $_REQUEST['s'];

$old_data = get_serial_data( $conf_file );

if ( isset( $_REQUEST['update'] )){
/*
    var_dump(mb_http_input('P'));
    echo 'bbbbbbbb***';
    echo mb_detect_encoding( $_REQUEST['s']['name'] );
    echo 'aaaaaaaaaaaaaaaa****';
    echo $_REQUEST['s']['name'];
exit;
*/
        
    $ret = check_convert_requested_data( $request, 
	$output, $display, $errors );

    if ( !$ret ) {
        $smarty = new smarty_c;
        $smarty->assign( 's',$display );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
	} else if ( $output == $old_data ) {
        $errors[] = '旧データから、修正されていません。';
        $smarty = new smarty_c;
        $smarty->assign( 's',$display );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }

    update_serial_data( $conf_file, $output );
    header('Location: ' . $_SERVER['PHP_SELF'] . '?complete=1');
    exit;
}
else {
    $smarty = new smarty_c;
    $smarty->assign( 's',$old_data );
    $smarty->display($template);
    exit;
}

function check_convert_requested_data( $input, &$output, &$display, &$errors ){

    $ret = true;
    $display = $input;
    array_walk_recursive( $display, 'array_specialchars' );    

    if ( !ctype_digit($input['pc_view']['top_page_count'] ) ){
	$errors[] = 'トップページ表示最大件数は数字しか入力できません。';
	$ret = false;
    }
    if ( !ctype_digit($input['pc_view']['past_page_count'] ) ){
	$errors[] = '過去ページ表示単位件数は数字しか入力できません。';
	$ret = false;
    }
    if ( !ctype_digit($input['pc_view']['past_page_snum'] ) ){
	$errors[] = '過去ページ表示単位数は数字しか入力できません。';
	$ret = false;
    }
    if ( !ctype_digit($input['mobile_view']['top_page_count'] ) ){
	$errors[] = 'トップページ表示最大件数は数字しか入力できません。';
	$ret = false;
    }
    if ( !ctype_digit($input['mobile_view']['past_page_count'] ) ){
	$errors[] = '過去ページ単位件数は数字しか入力できません。';
	$ret = false;
    }
    if ( !ctype_digit($input['mobile_view']['past_page_snum'] ) ){
	$errors[] = '過去ページ表示単位数は数字しか入力できません。';
	$ret = false;
    }
    if ( !ctype_digit($input['rss_view']['count'] ) ){
	$errors[] = 'RSS表示件数は数字しか入力できません。';
	$ret = false;
    }
    if ( !$ret ) return false;

    if ( $input['pc_view']['top_page_count'] <
	$input['pc_view']['past_page_count'] ) {
	$errors[] = 'トップページ表示最大件数は過去ページ表示単位件数以上で' .
		    'なくてはなりません。';
	$ret = false;
    }

    if ( $input['mobile_view']['top_page_count'] <
	$input['mobile_view']['past_page_count'] ) {
	$errors[] = 'トップページ表示最大件数は過去ページ表示単位件数以上で' .
		    'なくてはなりません。';
	$ret = false;
    }
    if ( !$ret ) return false;

    $output['url'] = $display['url'];
    $output['name'] = $display['name'];
    $output['sub_name'] = $display['sub_name'];
    $output['copyright'] = $display['copyright'];
    $output['icondir'] = $display['icondir'];
    $output['pc_view']['top_page_count'] = (int) $display['pc_view']['top_page_count'];
    $output['pc_view']['past_page_count'] = (int) $display['pc_view']['past_page_count'];
    $output['pc_view']['past_page_snum'] = (int) $display['pc_view']['past_page_snum'];
    $output['mobile_view']['top_page_count'] = (int) $display['mobile_view']['top_page_count'];
    $output['mobile_view']['past_page_count'] = (int) $display['mobile_view']['past_page_count'];
    $output['mobile_view']['past_page_snum'] = (int) $display['mobile_view']['past_page_snum'];
    $output['rss_view']['count'] = (int) $display['rss_view']['count'];

    return $ret;
}


?>
