<?php

require_once('./setup_admin.php');

require_once('./import_func.php');
//$conf_file = GT_BLOG_CONF_FILE;
$template = 'import.tpl';
$encodings = array( 'UTF-8' => 'UTF-8', 'EUC-JP' =>'EUC-JP', 'SJIS' =>'SJIS' );

$request = $_REQUEST['s'];

$old_data = get_serial_data( $conf_file );


if ( isset( $_REQUEST['import'] )){
    $request = $_REQUEST['s'];
    $ret = check_convert_requested_data( $request, 
	$output, $display, $errors );

    if ( !$ret ) {
        $smarty = new smarty_c;
        $smarty->assign( 's',$display );
        $smarty->assign( 'encoding_options',$encodings );
        $smarty->assign( 'user_options',user_options() );
        $smarty->assign( 'category_options',category_options() );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }
    performance('init');
    echo "インポート処理を開始します<br>\n";
//    update_serial_data( $conf_file, $output );
//    header('Location: ' . $_SERVER['PHP_SELF'] . '?complete=1');
//    var_dump($display);
    $ret = import_mt_format( $output['filename'], $output['encoding'], 
        $output['user_id'], $output['category_id'], $output['merge'], $infomations );
    if (!$ret ) echo 'エラーが発生しています<br>';
    echo "インポートが完了しました。<br>\n";
    echo '処理時間：' . performance() . '秒';
    
    exit;
} elseif ( isset( $_REQUEST['check'] )){
    $request = $_REQUEST['s'];
    $ret = check_convert_requested_data( $request, 
	$output, $display, $errors );
    if ( !$ret ) {
        $smarty = new smarty_c;
        $smarty->assign( 's',$display );
        $smarty->assign( 'encoding_options',$encodings );
        $smarty->assign( 'user_options',user_options() );
        $smarty->assign( 'category_options',category_options() );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }
    
    $data = file_get_contents( $output['filename'] );
    $data = mb_convert_encoding( $data, 'UTF-8', $output['encoding'] );

    echo 'ファイル内容<br>';
    echo '<pre>';
    echo htmlspecialchars($data);
}
else {
    $smarty = new smarty_c;
    $smarty->assign( 'encoding_options',$encodings );
    $smarty->assign( 'user_options',user_options() );
    $smarty->assign( 'category_options',category_options() );
    $smarty->display($template);
    exit;
}

function check_convert_requested_data( $input, &$output, &$display, &$errors ){

    global $encodings;
    $ret = true;
    
    $display = $input;
    array_walk_recursive( $display, 'array_specialchars' );    

    if ( !file_exists( $input['filename'] ) ){
        $errors[] = 'ファイルが存在しません。';
        $ret = false;
    } elseif ( !is_readable( $input['filename'] ) ){
        $errors[] = 'ファイルは存在しますが、読み込めません。';
        $ret = false;
    }

    if ( !isset($encodings[$input['encoding']] ) ){
        $errors[] = '存在しないエンコーディングが指定されました（バグ？）。';
        $ret = false;
    } 
    $master_user = master_user();
    if ( !isset($master_user[$input['user_id']] ) ){
        $errors[] = '存在しないユーザーが指定されました（バグ？）。';
        $ret = false;
    }
    $master_category = master_category();
    if ( !isset($master_category[$input['category_id']]) ){
        $errors[] = '存在しないカテゴリーが指定されました（バグ？）。';
        $ret = false;
    }
    
    $output['filename'] = $input['filename'];
    $output['encoding'] = $input['encoding'];
    $output['user_id'] = $input['user_id'];
    $output['category_id'] = $input['category_id'];
    $output['merge'] = $input['merge'];

    return $ret;
}

?>
