<?php

function import_mt_format($filename, $encoding, $user_id, $category_id, $merge, &$infomations){
    $infomations = array();

    // 現存する、全エントリデータの読み込み
    if ( $merge ) $gb_array = list_entry_all();
    else $gb_array = array();
//    echo '<pre>';
//    print_r($gb_array);
//    echo '****************';
//exit;
    // ファイルからの読み込みと配列への変換
    $mt_contents_arrays = mt_get_all_entry( $filename, $encoding );
    foreach ( $mt_contents_arrays as $content ){
        $mt_array[] = mt_convert_entry( $content );
    }
//    echo '<pre>';
//    print_r($mt_array);
    //独自形式に加工（現存するエントリデータとのマージ//
    $gb_array = mt_to_gb_array($mt_array, $gb_array, $user_id, $category_id);
/*
    echo '<pre>';
    print_r($gb_array);
*/
    // コメントの抽出と、エントリへの紐つけ
    $gbc_array = gb_to_gbc( $gb_array );
    $gbec_array = gbc_to_gbec( $gbc_array );

    // トラックバックの抽出と、エントリへの紐つけ
    $gbt_array = gb_to_gbt( $gb_array );
    $gbet_array = gbt_to_gbet( $gbt_array );

    // 余分なデータの削除
    foreach ( $gb_array as $entry_id => $gb_rec ){
        unset ( $gb_array[$entry_id]['comment'] );
        unset ( $gb_array[$entry_id]['trackback'] );
    }
    foreach ( $gbc_array as $comment_id => $gbc_rec ){
        unset ( $gbc_array[$comment_id]['relative_comment_id'] );
    }
    foreach ( $gbt_array as $trackback_id => $gbt_rec ){
        unset ( $gbt_array[$trackback_id]['relative_trackback_id'] );
    }
       
//    print_r($gbec_array);

    //現データの移動

    $ret = rename( GAKIBLO_SYSROOT . 'data', GAKIBLO_SYSROOT . 'data_backup_'. strftime('%Y%m%d%H%M%S'));
    if ( !$ret ) return $ret;

    //ディレクトリの作成
    $ret = mkdir ( GT_DATA_DIR );
    if ( !$ret ) return $ret;
    mkdir ( GT_DATA_DIR . 'entry' );
    if ( !$ret ) return $ret;
    mkdir ( GT_DATA_DIR . 'comment' );
    if ( !$ret ) return $ret;
    mkdir ( GT_DATA_DIR . 'entry_comment' );
    if ( !$ret ) return $ret;
    mkdir ( GT_DATA_DIR . 'trackback' );
    if ( !$ret ) return $ret;
    mkdir ( GT_DATA_DIR . 'entry_trackback' );
    if ( !$ret ) return $ret;
    mkdir ( GT_DATA_DIR . 'cache' );
    if ( !$ret ) return $ret;
    mkdir ( GT_DATA_DIR . 'cache_s' );
    if ( !$ret ) return $ret;
    mkdir ( GT_DATA_DIR . 'moblog' );
    if ( !$ret ) return $ret;
    mkdir ( GT_DATA_DIR . 'temp' );
    if ( !$ret ) return $ret;
   
    foreach ( $gb_array as $entry_id => $gb_rec ){
        $ret = insert_data_with_id( 'entry', $gb_rec, $entry_id );
        if (!$ret) return false;
    }
    foreach ( $gbc_array as $comment_id => $gbc_rec ){
        $ret = insert_data_with_id( 'comment', $gbc_rec, $comment_id );
        if (!$ret) return false;
    }
    foreach ( $gbec_array as $entry_id => $gbec_rec ){
        $ret = insert_data_with_id( 'entry_comment', $gbec_rec, $entry_id );
        if (!$ret) return false;
    }
    return true;

//    print_r($flip_categories);

    $not_in_category = array();
    $not_in_user = array();
    $p=0;
    foreach( $earrays as $k => $earray ){
        if ( !isset($flip_user[$earray['AUTHOR']] )){
            $not_in_user[$earray['AUTHOR']]++;
        }
        if ( isset( $earray['PRIMARY CATEGORY'] ) ){
            $cate =  $earray['PRIMARY CATEGORY'];
        } elseif ( isset( $earray['CATEGORY'][0] ) ){
            $cate = $earray['CATEGORY'][0];
        } else {
            $cate = '(指定なし)';
        }
        if ( !isset($flip_category[$cate] ) ){
            $not_in_category[$cate]++;
        }
    }
    exit;
}
/* mt形式配列から、gb内部形式配列に変換する。*/
function mt_to_gb_array( $mt_array, $gb_array, $user_id, $category_id ){

    // ユーザー,カテゴリーの取得、およびflip
    $master_user = master_user();
    $flip_user = array();
    foreach ( $master_user as $id => $v ){
        $flip_user[$v['name']] = $id;
    }
    $master_category = master_category();
    foreach ( $master_category as $id => $v ){
        $flip_category[$v['name']] = $id;
    }

    foreach ( $mt_array as $mtrec ){
        $gb_rec = array();
        if ( isset($flip_user[$mtrec['AUTHOR']]) ){
            //表示名が入ってる場合
            $gb_rec['user_id'] = $flip_user[$mtrec['AUTHOR']];
        } elseif ( isset($master_user[$mtrec['AUTHOR']]) ){
            // ユーザーＩＤが直接入ってる場合
            $gb_rec['user_id'] = $mtrec['AUTHOR'];
        } else {
            $gb_rec['user_id'] = $user_id;
        }
        $gb_rec['title'] = $mtrec['TITLE'];
        if ( isset( $mtrec['PRIMARY CATEGORY'] ) ){
            $work_category_name =  $mtrec['PRIMARY CATEGORY'];
        } elseif ( isset( $mtrec['CATEGORY'][0] ) ){
            $work_category_name =  $mtrec['CATEGORY'][0];
        } else {
            $work_category_name = NULL;
        }
        if ( isset($flip_category[$work_category_name]) ) {
            $gb_rec['category_id'] = $flip_category[$work_category_name];
        } else {
            $gb_rec['category_id'] = $category_id;
        }
        
        $gb_rec['date'] = strtotime($mtrec['DATE']);
        if ( strcasecmp( $mtrec['STATUS'], 'Draft' ) == 0 ) $gb_rec['status'] = 'Draft';
        else $gb_rec['status'] = 'Publish';
        $gb_rec['nl2br'] = (bool) $mtrec['CONVERT BREAKS'];
        $gb_rec['allow_comments'] = (bool) $mtrec['ALLOW COMMENTS'];
        $gb_rec['allow_pings'] = (bool) $mtrec['ALLOW PINGS'];
        $gb_rec['introduction'] = $mtrec['BODY'];
        $gb_rec['body'] = $mtrec['EXTENDED BODY'];
        if ( isset($mtrec['COMMENT']) and count ($mtrec['COMMENT'])){
            $gb_comment_array = array();
            foreach ( $mtrec['COMMENT'] as $mt_comment_rec ){
                $gb_comment_rec['author'] = $mt_comment_rec['AUTHOR'];
                $gb_comment_rec['email'] = $mt_comment_rec['EMAIL'];
                $gb_comment_rec['url'] = $mt_comment_rec['URL'];
                $gb_comment_rec['ip'] = $mt_comment_rec['IP'];
                $gb_comment_rec['date'] =  strtotime($mt_comment_rec['DATE']);
                $gb_comment_rec['body'] = $mt_comment_rec['BODY'];
                $gb_comment_array[] = $gb_comment_rec;
            }
            usort_rec_int( $gb_comment_array, 'date' );
            $gb_rec['comment'] = $gb_comment_array;
        }
        if ( isset($mtrec['PING']) and count ($mtrec['PING'])){
            $gb_trackback_array = array();
            foreach ( $mtrec['PING'] as $mt_ping_rec ){
                $gb_trackback_rec['title'] = $mt_ping_rec['TITLE'];
                $gb_trackback_rec['email'] = $mt_ping_rec['EMAIL'];
                $gb_trackback_rec['url'] = $mt_ping_rec['URL'];
                $gb_trackback_rec['ip'] = $mt_ping_rec['IP'];
                $gb_trackback_rec['date'] =  strtotime($mt_ping_rec['DATE']);
                $gb_trackback_rec['blog_name'] = $mt_ping_rec['BLOG_NAME'];
                $gb_trackback_rec['body'] = $mt_ping_rec['BODY'];
                $gb_trackback_array[] = $gb_trackback_rec;
            }
            usort_rec_int( $gb_trackback_array, 'date' );
            $gb_rec['trackback'] = $gb_trackback_array;
        }
        $gb_array[] = $gb_rec;
    }

    usort_rec_int( $gb_array, 'date' );
    $i=0;
    foreach ( $gb_array as $w ){
        $i++;
        $ret_array[$i]=$w;
    }
    return $ret_array;
}
/* gb内部形式配列から、コメントを抽出し、ソートする。(gbc内部形式配列）*/
function gb_to_gbc( $gb_array ){
    $gbc_array = array();
    foreach ( $gb_array as $entry_id => $gb_rec ){
        if ( isset($gb_rec['comment'] ) and count($gb_rec['comment']) ){
            foreach ( $gb_rec['comment'] as $relative_comment_id => $gbc_rec ){
                $w = $gbc_rec;
                $w['entry_id'] = $entry_id;
                $w['relative_comment_id'] = $relative_comment_id;
                $i_array++;
                $gbc_array[] = $w;
            }
        }
    }
    usort_rec_int( $gbc_array, 'date' );
    $i=0;
    $ret_array = array();
    foreach ( $gbc_array as $w ){
        $i++;
        $ret_array[$i]=$w;
    }
    return $ret_array;
}
/* gb内部形式配列から、トラックバックを抽出し、ソートする。(gbt内部形式配列）*/
function gb_to_gbt( $gb_array ){
    $gbt_array = array();
    foreach ( $gb_array as $entry_id => $gb_rec ){
        if ( isset($gb_rec['trackback'] ) and count($gb_rec['trackback']) ){
            foreach ( $gb_rec['trackback'] as $relative_trackback_id => $gbt_rec ){
                $w = $gbt_rec;
                $w['entry_id'] = $entry_id;
                $w['relative_trackback_id'] = $relative_trackback_id;
                $gbt_array[] = $w;
            }
        }
    }
    usort_rec_int( $gbt_array, 'date' );
    $i=0;
    $ret_array = array();
    foreach ( $gbt_array as $w ){
        $i++;
        $ret_array[$i]=$w;
    }
    return $ret_array;
}
/* gbc内部形式配列から、エントリからのポインタを作成する。(gbec内部形式配列）*/
function gbc_to_gbec( $gbc_array ){
    $gbec_array = array();
    foreach ( $gbc_array as $comment_id => $gbc_rec ){
        $gbec_array[$gbc_rec['entry_id']][$comment_id] = true;
    }
    return $gbec_array;
}
/* gbt内部形式配列から、エントリからのポインタを作成する。(gbet内部形式配列）*/
function gbt_to_gbet( $gbt_array ){
    $gbet_array = array();
    foreach ( $gbt_array as $trackback_id => $gbt_rec ){
        $gbet_array[$gbt_rec['entry_id']][$trackback_id] = true;
    }
    return $gbet_array;
}
function mt_convert_entry( $content ){

    static $separator_section = "\n-----\n";
//var_dump($content);
    $section_array = explode( $separator_section, $content );
//    print_r($section_array);

    $rec = array();

    foreach( $section_array as $sa ){
        if ( strncasecmp('BODY:', $sa, 5 ) == 0 ){
	        $w = explode( "\n", $sa, 2 );
	        $rec['BODY'] = trim($w[1]); 
	    } elseif ( strncasecmp('EXTENDED BODY:', $sa, 14 ) == 0 ) { 
	        $w = explode( "\n", $sa, 2 );
	        $rec['EXTENDED BODY'] = trim($w[1]);
        } elseif ( strncasecmp('EXCERPT:', $sa, 8 ) == 0 ) {
	        $w = explode( "\n", $sa, 2 );
	        $rec['EXCERPT'] = trim($w[1]);
        } elseif ( strncasecmp('COMMENT:', $sa, 8 ) == 0 ) {
	        $w = explode( "\n", $sa, 2 );
	        $w2 = mt_parse_comment_section( $w[1] );
	        $rec['COMMENT'][] = $w2;
        } elseif ( strncasecmp('PING:', $sa, 5 ) == 0 ) {
	        $w = explode( "\n", $sa, 2 );
	        $w2 = mt_parse_ping_section( $w[1] );
            $rec['PING'][] = $w2;
	    } else {
/*
echo '****************************************';
	var_dump( $sa );
*/
	        $metadata_array = explode( "\n", $sa );
//	var_dump($sa);
//	var_dump( $metadata_array );exit;

            foreach ( $metadata_array as $ma ){
                if ( strncasecmp('AUTHOR:', $ma, 7 ) == 0 ){
                    $w = explode( ":", $ma, 2 );
                    $rec['AUTHOR'] = trim($w[1]); 
//		var_dump($ma);var_dump($w);exit;
                } elseif ( strncasecmp('TITLE:', $ma, 6 ) == 0 ){
                    $w = explode( ":", $ma, 2 );
                    $rec['TITLE'] = trim($w[1]);
                } elseif ( strncasecmp('DATE:', $ma, 5 ) == 0 ){
                    $w = explode( ":", $ma, 2 );
                    $rec['DATE'] = trim($w[1]);
                } elseif ( strncasecmp('PRIMARY CATEGORY:', $ma, 17 ) == 0 ){
                    $w = explode( ":", $ma, 2 );
                    $rec['PRIMARY CATEGORY'] = trim($w[1]);
                } elseif ( strncasecmp('CATEGORY:', $ma, 9 ) == 0 ){
                    $w = explode( ":", $ma, 2 );
                    $rec['CATEGORY'][] = trim($w[1]);
                } elseif ( strncasecmp('STATUS:', $ma, 7 ) == 0 ){
                    $w = explode( ":", $ma, 2 );
                    $rec['STATUS'] = trim($w[1]);
                } elseif ( strncasecmp('CONVERT BREAKS:', $ma, 15 ) == 0 ){
                    $w = explode( ":", $ma, 2 );
                    $rec['CONVERT BREAKS'] = trim($w[1]);
                } elseif ( strncasecmp('ALLOW COMMENTS:', $ma, 15 ) == 0 ){
                    $w = explode( ":", $ma, 2 );
                    $rec['ALLOW COMMENTS'] = trim($w[1]);
                } elseif ( strncasecmp('ALLOW PINGS:', $ma, 12 ) == 0 ){
                    $w = explode( ":", $ma, 2 );
                    $rec['ALLOW PINGS'] = trim($w[1]);
                }
            }
        }
    }
    return $rec;
}
function mt_parse_ping_section( $section_text ){
    $rec = array();
    while(true){
        $two_string = explode( "\n", $section_text, 2 );

	if ( strncasecmp('TITLE:', $two_string[0], 6 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['TITLE'] = trim($w[1]); 
	} elseif ( strncasecmp('EMAIL:', $two_string[0], 6 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['EMAIL'] = trim($w[1]); 
	} elseif ( strncasecmp('URL:', $two_string[0], 4 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['URL'] = trim($w[1]); 
	} elseif ( strncasecmp('IP:', $two_string[0], 3 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['IP'] = trim($w[1]); 
	} elseif ( strncasecmp('DATE:', $two_string[0], 5 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['DATE'] = trim($w[1]); 
	} elseif ( strncasecmp('BLOG NAME:', $two_string[0], 10 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['BLOG NAME'] = trim($w[1]); 
	} else {
	    $rec['BODY'] = $section_text;
	    return $rec;
	}
	$section_text = $two_string[1];
    }
}
function mt_parse_comment_section( $section_text ){
    $rec = array();
    while(true){
        $two_string = explode( "\n", $section_text, 2 );

        if ( strncasecmp('AUTHOR:', $two_string[0], 7 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['AUTHOR'] = trim($w[1]); 
        } elseif ( strncasecmp('EMAIL:', $two_string[0], 6 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['EMAIL'] = trim($w[1]); 
	    } elseif ( strncasecmp('URL:', $two_string[0], 4 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['URL'] = trim($w[1]); 
	    } elseif ( strncasecmp('IP:', $two_string[0], 3 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['IP'] = trim($w[1]); 
	    } elseif ( strncasecmp('DATE:', $two_string[0], 5 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['DATE'] = trim($w[1]); 
	    } else {
	        $rec['BODY'] = $section_text;
	        return $rec;
	    }
	    $section_text = $two_string[1];
    }
}
function mt_get_all_entry( $filename, $from_encoding ){

    $separator_entry = "\n--------\n";

    $all_contents = file_get_contents( $filename );
//    if ( $from_encoding == 'auto' ) $from_encoding = 'UTF-8,EUC-JP,SJIS';
    $all_contents = mb_convert_encoding( $all_contents, 'UTF-8', $from_encoding );
    $all_contents_array = explode( $separator_entry, $all_contents );
    foreach ( $all_contents_array as $k => $v ) {
        if ( !$v ) {
            unset ( $all_contents_array[$k] );
        } else {
            $all_contents_array[$k] = $all_contents_array[$k] . "\n";
        }
    }
    return $all_contents_array;

}

?>
