<?php

function check_mt_format($filename, $encoding, &$infomations){
    $infomations = array();
    $fp = fopen( $filename, 'r' );
    if ( !$fp ) return false;

    while ( true ){
        $content = mt_get_next_entry($fp);
        if (!$content) break;
        $earrays[] = mt_convert_entry( $content );
//        print_r($earrays);
    }

    $master_user = master_user();
    $flip_user = array();
    foreach ( $master_user as $id => $v ){
        $flip_user[$v['name']] = $id;
    }
    $master_category = master_category();
    foreach ( $master_category as $id => $v ){
        $flip_category[$v['name']] = $id;
    }
//    print_r($flip_categories);

    $not_in_category = array();
    $not_in_user = array();
    $p=0;
    foreach( $earrays as $k => $earray ){
        if ( !isset($flip_user[$earray['AUTHOR']] )){
            $not_in_user[$earray['AUTHOR']]++;
        }
        if ( isset( $earray['PRIMARY CATEGORY'] ) ){
            $cate =  $earray['PRIMARY CATEGORY'];
        } elseif ( isset( $earray['CATEGORY'][0] ) ){
            $cate = $earray['CATEGORY'][0];
        } else {
            $cate = '(指定なし)';
        }
        if ( !isset($flip_category[$cate] ) ){
            $not_in_category[$cate]++;
        }
    }
    echo '<pre>';
    print_r($not_in_user);
    print_r($not_in_category);
    exit;
}
function mt_convert_entry( $content ){

    static $separator_section = "\n-----\n";
//var_dump($content);
    $section_array = explode( $separator_section, $content );
//    print_r($section_array);

    $rec = array();

    foreach( $section_array as $sa ){
	if ( strncasecmp('BODY:', $sa, 5 ) == 0 ){
	    $w = explode( "\n", $sa, 2 );
	    $rec['BODY'] = trim($w[1]); 
	} elseif ( strncasecmp('EXTENDED BODY:', $sa, 14 ) == 0 ) { 
	    $w = explode( "\n", $sa, 2 );
	    $rec['EXTENDED BODY'] = trim($w[1]);
        } elseif ( strncasecmp('EXCERPT:', $sa, 8 ) == 0 ) {
	    $w = explode( "\n", $sa, 2 );
	    $rec['EXCERPT'] = trim($w[1]);
        } elseif ( strncasecmp('COMMENT:', $sa, 8 ) == 0 ) {
	    $w = explode( "\n", $sa, 2 );
	    $w2 = mt_parse_comment_section( $w[1] );
	    $rec['COMMENT'][] = $w2;
        } elseif ( strncasecmp('PING:', $sa, 5 ) == 0 ) {
	    $w = explode( "\n", $sa, 2 );
	    $w2 = mt_parse_ping_section( $w[1] );
	    $rec['PING'][] = $w2;
	} else {
/*
echo '****************************************';
	var_dump( $sa );
*/
	    $metadata_array = explode( "\n", $sa );
//	var_dump($sa);
//	var_dump( $metadata_array );exit;

	  foreach ( $metadata_array as $ma ){
	    if ( strncasecmp('AUTHOR:', $ma, 7 ) == 0 ){
                $w = explode( ":", $ma, 2 );
                $rec['AUTHOR'] = trim($w[1]); 
//		var_dump($ma);var_dump($w);exit;
	    } elseif ( strncasecmp('TITLE:', $ma, 6 ) == 0 ){
                $w = explode( ":", $ma, 2 );
                $rec['TITLE'] = trim($w[1]);
	    } elseif ( strncasecmp('DATE:', $ma, 5 ) == 0 ){
                $w = explode( ":", $ma, 2 );
                $rec['DATE'] = trim($w[1]);
	    } elseif ( strncasecmp('PRIMARY CATEGORY:', $ma, 17 ) == 0 ){
                $w = explode( ":", $ma, 2 );
                $rec['PRIMARY CATEGORY'] = trim($w[1]);
	    } elseif ( strncasecmp('CATEGORY:', $ma, 9 ) == 0 ){
                $w = explode( ":", $ma, 2 );
                $rec['CATEGORY'][] = trim($w[1]);
	    } elseif ( strncasecmp('STATUS:', $ma, 7 ) == 0 ){
                $w = explode( ":", $ma, 2 );
                $rec['STATUS'] = trim($w[1]);
	    } elseif ( strncasecmp('ALLOW COMMENTS:', $ma, 15 ) == 0 ){
                $w = explode( ":", $ma, 2 );
                $rec['ALLOW COMMENTS'] = trim($w[1]);
	    } elseif ( strncasecmp('ALLOW PINGS:', $ma, 12 ) == 0 ){
                $w = explode( ":", $ma, 2 );
                $rec['ALLOW PINGS'] = trim($w[1]);
	    }
	  }
	}

    }
    return $rec;
}
function mt_parse_ping_section( $section_text ){
    $rec = array();
    while(true){
        $two_string = explode( "\n", $section_text, 2 );

	if ( strncasecmp('TITLE:', $two_string[0], 6 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['TITLE'] = trim($w[1]); 
	} elseif ( strncasecmp('EMAIL:', $two_string[0], 6 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['EMAIL'] = trim($w[1]); 
	} elseif ( strncasecmp('URL:', $two_string[0], 4 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['URL'] = trim($w[1]); 
	} elseif ( strncasecmp('IP:', $two_string[0], 3 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['IP'] = trim($w[1]); 
	} elseif ( strncasecmp('DATE:', $two_string[0], 5 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['DATE'] = trim($w[1]); 
	} elseif ( strncasecmp('BLOG NAME:', $two_string[0], 10 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['BLOG NAME'] = trim($w[1]); 
	} else {
	    $rec['BODY'] = $section_text;
	    return $rec;
	}
	$section_text = $two_string[1];
    }
}
function mt_parse_comment_section( $section_text ){
    $rec = array();
    while(true){
        $two_string = explode( "\n", $section_text, 2 );

	if ( strncasecmp('AUTHOR:', $two_string[0], 7 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['AUTHOR'] = trim($w[1]); 
	} elseif ( strncasecmp('EMAIL:', $two_string[0], 6 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['EMAIL'] = trim($w[1]); 
	} elseif ( strncasecmp('URL:', $two_string[0], 4 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['URL'] = trim($w[1]); 
	} elseif ( strncasecmp('IP:', $two_string[0], 3 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['IP'] = trim($w[1]); 
	} elseif ( strncasecmp('DATE:', $two_string[0], 5 ) == 0 ){
            $w = explode( ":", $two_string[0], 2 );
            $rec['DATE'] = trim($w[1]); 
	} else {
	    $rec['BODY'] = $section_text;
	    return $rec;
	}
	$section_text = $two_string[1];
    }
}
function mt_get_next_entry($fp){
    static $remain_content;
    static $encoding;
    static $separator_entry = "\n--------\n";

    while ( true ){
//echo '@@@';
//var_dump($remain_content);
        $two_string = explode( $separator_entry, $remain_content, 2 );

//var_dump( $two_string );
	if ( isset($two_string[1]) ){
	    if ( strlen($two_string[0]) == 0  ){
		$remain_content = $two_string[1];
	    } else {
	        $entry_text = $two_string[0];
	        $remain_content = $two_string[1];
		if ( strlen($entry_text) == 0 ) return false;
	        return $entry_text . "\n";
	    }
	} else {
	    $rec = fread( $fp, 10000 );
/*
echo '@@@';
echo $rec;
$dz = fopen( 'c.txt', 'wb');
fwrite ($dz, 'aaa');
var_dump(fwrite($dz,$rec));
fwrite ($dz, 'bbb'. "\n");
fclose($dz);
*/
	    if ( strlen($rec) == 0 ){
		$entry_text = $two_string[0];
		$remain_content = '';
		if ( strlen($entry_text) == 0 ) return false;
		return $entry_text . "\n";
	    }
	    $remain_content = $remain_content . $rec;
	//echo $rec;echo '*';
	}
    }
    
}
?>
