<?php
/*
    コメントを登録して、リダイレクトしexitする。
    入力エラーも含め、エラーの場合には、テンプレート変数を割り当て、リターンする
*/

// この関数は、管理者しか使わないので、エラー時は、メッセージも表示し落とす。
function do_get_comment( &$smarty ){

    $entry_data = get_entry_all( $_REQUEST['entry']);
    translate_entry_for_display( $entry_data );

    if (!$entry_data ){
        user_error('エントリー参照に失敗しました',E_USER_WARNING);
        exit;
    }
    $comment_data = $entry_data['comment'][$_REQUEST['comment']];
    if ( !$comment_data ){
        user_error('該当エントリに該当コメントが存在しません。');
        exit;
    }



    $entry[$_REQUEST['entry']] = $entry_data;

    $smarty->assign('entry', $entry);
    
    //ＤＢが壊れてるとき等、こちらの値のほうが手堅いために置き換える。
    $comment_data['entry_id'] = $_REQUEST['entry'];

    $comment_data['comment_id'] = $_REQUEST['comment'];
    $smarty->assign('cmt', $comment_data );

}



function do_insert_comment( &$smarty ){
//echo "bbbb\n";
    $master_comment = master_comment();
    $smarty->assign('comment', $master_comment );
    $request = filter_request( $_REQUEST['cmt'] );

    $ret_input_check = check_convert_requested_data( $request, 
	    $output, $display, $errors );

    $entry_id = $_REQUEST['entry'];
    $entry_rec = get_entry_all( $entry_id, false );
    translate_entry_for_display( $entry_rec );

    $entry[$entry_id] = $entry_rec;
    $smarty->assign('entry', $entry);

    $ret_input_check2 = true;
    if ( $master_comment['protect_by_question'] and
         ( mktime() - $entry_rec['date'] ) > $master_comment['question_date']*60*60*24 
    ){
        $protect_by_question = true;
        $smarty->assign('protect_by_question', true );
        $ret_input_check2 = check_convert_requested_data2( $request,
            $display, $errors );
    }
    if ( !$ret_input_check or !$ret_input_check2 ){ 
        $smarty->assign('cmt', $display );
        $smarty->assign('comment_errors', $errors );
        return false;
    }


    if ( !$entry_rec ){
        $errors[] = 'エントリーが存在しません。削除されたようです。';
        $smarty->assign('cmt', $display );
        $smarty->assign('comment_errors', $errors );
        return false;
    }
    if ( $entry_rec['status'] <> 'Publish' or
         !$entry_rec['allow_comments'] ){
        $errors[] = 'コメントできません。状態が変わったか、コメント不許可になったようです。';
        $smarty->assign('cmt', $display );
        $smarty->assign('comment_errors', $errors );
        return false;
    }
    require_once('comment_handle.php');
    $ret = insert_comment_submit( $entry_id, $output, $comment_id, $rand);
    if (!$ret ){
        user_error('コメント作成に失敗しました',E_USER_WARNING);
        exit;
    }

    $master_user = master_user();
    $user_rec = $master_user[$entry_rec['user_id']];
//    print_r($user_rec);
    if ( $user_rec['smtp_host'] and $user_rec['mail_address'] ){
        $master_blog = master_blog();
        $mail_subject = '[' . $master_blog['name'] . '][コメント受信]';
        $mail_subject .=  $entry_rec['title'];


        $mail_body = '';
        $mail_body .= "コメントを受信しました。\r\n";
        $mail_body .= "参照URL:" . $master_blog['url'] . "?e=$entry_id#comment$comment_id\r\n";
        $mail_body .= "******************************************************************\r\n";
        $mail_body .= "投稿者名:              " . $output['author'] . "\r\n";
        $mail_body .= "投稿者メールアドレス:  " . $output['mail'] . "\r\n";
        $mail_body .= "投稿者URL:             " . $output['url'] . "\r\n";
        $mail_body .= "投稿者ホスト:          " . $output['host'] . "\r\n";
        $mail_body .= "投稿者User-Agent:      " . $output['user_agent'] . "\r\n";
        $mail_body .= "投稿者Accept-Language: " . $output['accept_language'] . "\r\n";
        $mail_body .= "コメント:\r\n";
        $mail_body .= $output['body'] . "\r\n";
        $mail_body .= "******************************************************************\r\n";
        $mail_body .= "自動検閲によりコメントは、反映されない場合があります。\r\n";
        $mail_body .= "自動検閲の対象になったコメントを反映してもよい場合は、以下のURLを実行してください。\r\n";
        $s = md5_entry_owner_password_and_rand( $entry_id, $rand );
        $mail_body .= $master_blog['url'] . "comment_update.php?entry=$entry_id&rand=$rand&md5password=$s\r\n";
        
        
        require_once('gb_mail.php');
        $ret = gb_mail( $user_rec['smtp_host'], $output['author'], $user_rec['mail_address'],
                        $user_rec['mail_address'], $mail_subject, $mail_body );
        if (!$ret) user_error("通知メール送信に失敗しました。");
    }




    if ( $master_comment['protect_by_cookie'] ){
//        set_comment_session( $rand );
        setcookie("rand",$rand,time() + 60);
        header("Location: comment_update.php?entry=$entry_id");
    } else {
        header("Location: comment_update.php?entry=$entry_id&rand=$rand");
    }
    exit;
    $del_smarty_cache = list_comment_smarty_cache( $entry_id, $entry_rec['category_id'] );

//    echo '<pre>';
//    print_r( $del_smarty_cache );

    foreach ( $del_smarty_cache as $v){
        $smarty->clear_cache(null, $v );
    }
    header("Location: index.php?e=$entry_id#comment$comment_id");
    exit;
}



function do_update_comment( &$smarty ){



    $entry_id = $_REQUEST['entry'];
    $comment_id = $_REQUEST['comment'];
    $entry_data = get_entry_all( $entry_id );
    translate_entry_for_display( $entry_data );
    if (!$entry_data ){
        user_error('エントリー参照に失敗しました',E_USER_WARNING);
        exit;
    }
    $comment_data = $entry_data['comment'][$comment_id];
    if ( !$comment_data ){
        user_error('該当エントリに該当コメントが存在しません。');
        exit;
    }

    $request = filter_request( $_REQUEST['cmt'] );

    $ret_input_check = check_convert_requested_data( $request, 
	    $output, $display, $errors );

    $entry_rec = get_entry_all( $entry_id );
    translate_entry_for_display( $entry_rec );

    $entry[$entry_id] = $entry_rec;
    $smarty->assign('entry', $entry);
    
    $display['entry_id'] = $entry_id;
    $display['comment_id'] = $comment_id;
    if ( !$ret_input_check ){ 
        $smarty->assign('cmt', $display );
        $smarty->assign('comment_errors', $errors );
        return false;
    }

    $output['date'] = $comment_data['date'];
    $output['ip'] = $comment_data['ip'];
    $output['host'] = $comment_data['host'];
    $output['entry_id'] = $comment_data['entry_id'];
    $output['user_agent'] = $comment_data['user_agent'];
    $output['accept_language'] = $comment_data['accept_language'];
    
    $ret = update_comment( $comment_id, $output );
    if (!$ret ){
        user_error('コメント更新に失敗しました',E_USER_WARNING);
        exit;
    }
    $del_smarty_cache = list_comment_update_smarty_cache( $entry_id );

//    echo '<pre>';
//    print_r( $del_smarty_cache );

    foreach ( $del_smarty_cache as $v){
        $smarty->clear_cache(null, $v );
    }
    

    header("Location: index.php?e=$entry_id#comment$comment_id");
    exit;
}



function do_delete_comment( &$smarty ){

    $entry_id = $_REQUEST['entry'];
    $comment_id = $_REQUEST['comment'];

    //print_r( $_REQUEST );

    $entry_data = get_entry_all( $entry_id );
    translate_entry_for_display( $entry_data );
//    print_r( $entry_data);
    if (!$entry_data ){
        user_error('エントリー参照に失敗しました',E_USER_WARNING);
        exit;
    }
    $comment_data = $entry_data['comment'][$comment_id];
    if ( !$comment_data ){
        user_error('該当エントリに該当コメントが存在しません。');
        exit;
    }

    $ret = delete_comment( $comment_id );
    if (!$ret ){
        user_error('コメント削除に失敗しました',E_USER_WARNING);
        exit;
    }

//    echo '<pre>end delete entry';
//    print_r($original);
    $del_smarty_cache = list_comment_smarty_cache( $entry_id, $entry_data['category_id'] );

//    echo '<pre>';
//    print_r( $del_smarty_cache );

    foreach ( $del_smarty_cache as $v){
        $smarty->clear_cache(null, $v );
    }
    header("Location: index.php?e=$entry_id#comment");
    exit;

}

function check_convert_requested_data( $input, &$output, &$display, &$errors ){

    
    $ret = true;
    $display = $input;

    array_walk_recursive( $display, 'array_specialchars' );    

    $master_comment = master_comment();
//    $master_category = master_category();
//    $master_status = master_status();
//    $master_user = master_user();

    if ( trim($input['author']) == '' ) {
        $errors[] = 'お名前は、必ず指定してください。';
        $ret = false;
    }
    if ( trim($input['body']) == '' ) {
        $errors[] = 'コメントは、必ず指定してください。';
        $ret = false;
    }
    if ( trim($input['url']) !== '' and !check_url(trim($input['url']))){
        $errors[] = 'URLに間違いがあります。';
        $ret = false;
    }

    if ( $master_comment['maxlen_author'] > 0 and mb_strlen(trim($input['author'])) > $master_comment['maxlen_author'] ){
        $errors[] = 'お名前は、' .  $master_comment['maxlen_author'] . '文字以内で入力してください。';
        $ret = false;
    }
    if (  $master_comment['maxlen_mail'] > 0 and mb_strlen(trim($input['mail'])) > $master_comment['maxlen_mail'] ){
        $errors[] = 'メールアドレスは、' .  $master_comment['maxlen_mail'] . '文字以内で入力してください。';
        $ret = false;
    }
    if ( $master_comment['maxlen_url'] > 0 and mb_strlen(trim($input['url'])) > $master_comment['maxlen_url'] ){
        $errors[] = 'ＵＲＬは、' .  $master_comment['maxlen_url'] . '文字以内で入力してください。';
        $ret = false;
    }
    if (  $master_comment['maxlen_body'] > 0 and mb_strlen($input['body']) > $master_comment['maxlen_body'] ){
        $errors[] = 'コメントは、' .  $master_comment['maxlen_body'] . '文字以内で入力してください。';
        $ret = false;
    }
     
    $output['author'] = trim($input['author']);
    $output['mail'] = trim($input['mail']);
    $output['url'] = trim($input['url']);
    $output['ip'] = $_SERVER["REMOTE_ADDR"];
    $output['host'] = gethostbyaddr($_SERVER["REMOTE_ADDR"]);
    $output['user_agent'] = $_SERVER["HTTP_USER_AGENT"];
    $output['accept_language'] = $_SERVER["HTTP_ACCEPT_LANGUAGE"];
    $output['date'] = mktime();
    $output['body'] = $input['body'];
    $output['entry_id'] = $input['entry_id'];

    return $ret;
}


function check_convert_requested_data2( $input, &$display, &$errors ){

    $master_comment = master_comment();

    $ret = true;
    if ( trim($input['question_answer']) == '' ) {
        $errors[] = '申し訳ありませんが、' .$master_comment['question_date'] .'日以前のエントリーにコメントする場合は、質問に回答をお願いします。';
        $ret = false;
    } elseif ( trim($input['question_answer']) <> trim($master_comment['question_answer'] ) ) {
        $errors[] = '質問の回答が間違っています。';
        $ret = false;
    }
    $display['question_answer'] = trim($input['question_answer']);

    return $ret;
}
?>