<?php
define("SMTP_TIMEOUT", 5);
function gb_sockopen($smtphost, $smtpport = 25, $smtptimeout = SMTP_TIMEOUT)
{
//    echo '<pre>';
    $sock = fsockopen($smtphost, $smtpport, $errno, $errstr, $smtptimeout);
    return $sock;
}
function gb_sockclose($sock)
{
    fclose($sock);
}
function gb_putcmd($sock,$command)
{
//    echo "command:[$command]";
    $ret = fputs($sock, $command."\r\n");
    if ( !$ret ) {
	gb_sockclose($sock);
	return FALSE;
    }
    return TRUE;
}
function gb_senddata($sock, $alldata)
{
    $ret = fputs($sock, $alldata."\r\n.\r\n");
    if ( !$ret ) {
	gb_sockclose();
	return FALSE;
    }
    return TRUE;
}
function gb_getresponse( $sock, $continue_flag = false ) {
    $ret = _gb_getallresponse( $sock, $all_response, $digit1 );
    if ( !$ret ){
	return false;
    } elseif (!($digit1 == '2' || $digit1 == '3')) {
	if ( $continue_flag ) {
	} else {
	    gb_putcmd("QUIT");
	    _gb_getallresponse( $sock, $all_response, $digit1 );
	    $sockclose();
	}
	return 2;
    }
    return 1;
}
function _gb_getallresponse( $sock, &$all_response, &$last_digit1 ) {
    $all_response = '';
    do {
	socket_set_timeout($sock,SMTP_TIMEOUT, 0);
    	$response = fgets($sock, 512);
//    echo 'response:' . $response ."\n";
	if ($response === false) return false;
	$socket_status = socket_get_status($sock);
	if ( $socket_status['timed_out'] ) {
	    return false;
	}
    	$digit1   = substr($response, 0, 1);
    	$digit4   = substr($response, 3, 1);
	$all_response .= $response;
    } 
    while ( $digit4 <> ' ' and ( $digit1 =='2' or $digit1 == '3' ) or
	$digit1 == '0'
	);
    $last_digit1 = $digit1;
    return true;
}
?>
