<?php
/*
    usage {trackback_url
                entry=$entry_number
                rdf=false : falseがデフォルト、RDF用の表示
                show=false : trueにすると、期限付きトラックバックの内容を表示します。
                             falseだと、ボタン表示
                }
*/

function smarty_function_trackback_url( $params, &$smarty ){

    $master_blog = master_blog();
    $master_trackback = master_trackback();

//    exit;

    $entry_id = $params['entry'];
    $rdf = $params['rdf'];
    if ( !isset($rdf) ) $rdf = false;
    if ( !isset($show) ) $show = false;



    if ( $master_trackback['timelimit_trackback_url'] and $_REQUEST['do'] !== 'show_trackback_url' ){
        if ( $rdf ){
            return '';
        } else {
            $string = "<FORM method=\"POST\" action=\"index.php?do=show_trackback_url#trackback\">" .
                  "<INPUT type=\"hidden\" name=\"entry\" value=\"$entry_id\">" .
                  "<INPUT type=\"submit\" name=\"insert\" value=\"トラックバックＵＲＬを参照する。\">";
            return $string;
        }
    }
    
    if ( $master_trackback['timelimit_trackback_url'] ){
        $md5_key = md5_trackback_key_generate( $entry_id, time(), $b_time );
        $url_w = $master_blog['url'] . 'trackback.php?e=' .$entry_id. '&k=' .$md5_key;
        if ( $master_trackback['sup_string'] <> '' ){
            $url_w .= '&' . $master_trackback['sup_string'];
        }
        $url_w_setsumei = '<br><br>トラックバックＵＲＬの有効期限：' . 
            strftime("%c", $b_time + TB_TIMELIMIT_UNIT * TB_TIMELIMIT_NUM );
    } else {
        $url_w = $master_blog['url'] . 'trackback.php?e=' .$entry_id;
        if ( $master_trackback['sup_string'] <> '' ){
            $url_w .= '&' . $master_trackback['sup_string'];
        }
    }

    if ( $rdf ){
        if ( $master_trackback['hide_trackback_url'] or  
             $master_trackback['timelimit_trackback_url'] )
            return '';
        else return "trackback:ping=\"$url_w\"";
    } else {
        if ( $master_trackback['hide_trackback_url'] ){
            $string = 'document.write(\'' . $url_w . '\');';

            $js_encode = '';
            for ($x=0; $x < strlen($string); $x++) {
                $js_encode .= '%' . bin2hex($string[$x]);
            }

            return '<script type="text/javascript">eval(unescape(\''.$js_encode.'\'))</script>' .
                    $url_w_setsumei;
        } else {
            return $url_w . $url_w_setsumei;
        }
    }
}
?>