<?php
/*
    usage {_categories}
               
*/

function smarty_insert_categories( $params, &$smarty ){

    if ( !isset($params['max']) ) $params['max'] = 5;

    $smarty_categories = new smarty_c;
    $smarty_categories_cache_id = 'categories|' . which_view();
//echo $smarty_categories_cache_id;
    $smarty_categories->caching = 2;
    $smarty_categories->cache_lifetime = -1; 
    if ( !$smarty_categories->is_cached( 'categories.tpl', $smarty_categories_cache_id ) ) {
        process_categories( $smarty_categories, $params );
    }
    return $smarty_categories->fetch('categories.tpl', $smarty_categories_cache_id );
}
function process_categories( &$smarty_categories, $params ){
    $category = master_category();
    foreach ( $category as $k => $v ){
        $category[$k]['count'] = count(read_cache( $k ));
    }
    $smarty_categories->assign( 'category', $category );
}
?>