<?php
/*
    usage {insert name="month_navi" attributes=$attributes}
*/

function smarty_insert_month_navi( $params, &$smarty ){

    $smarty_month_navi = new smarty_c;

    $smarty_month_navi->caching = 2;
    $smarty_month_navi->cache_lifetime = -1;
//    $smarty_month_navi_cache_id = 'month_navi|' . $params['attributes']['category_id'] . '|' .
    $smarty_month_navi_cache_id = 'month_navi|' .
        $params['attributes']['value'] . '|' . which_view();
    if ( !$smarty_month_navi->is_cached('month_navi.tpl', $smarty_month_navi_cache_id) ) process_month_navi( $smarty_month_navi, $params);
    return $smarty_month_navi->fetch('month_navi.tpl', $smarty_month_navi_cache_id );
}
function process_month_navi( &$smarty_month_navi, $params ){


//    $master_blog = master_blog();
//    $smarty_month_navi->assign( 'blog', $master_blog );
    $smarty_month_navi->assign( 'attributes', $params['attributes'] );

    $this_month =  $params['attributes']['value'];
    list( $previous_month, $next_month ) = 
        cache_previous_next_month( $this_month );
    $smarty_month_navi->assign( 'this_month', 
                array( 'month'=> $this_month, 
                    'date'=> mktime(0,0,0,substr($this_month,4,2),1,
                            substr($this_month,0,4) )));
    if ( $previous_month )
    $smarty_month_navi->assign( 'previous_month', 
                array( 'month'=> $previous_month, 
                    'date'=> mktime(0,0,0,substr($previous_month,4,2),1,
                            substr($previous_month,0,4) )));
    if ( $next_month )
    $smarty_month_navi->assign( 'next_month', 
                array( 'month'=> $next_month, 
                    'date'=> mktime(0,0,0,substr($next_month,4,2),1,
                            substr($next_month,0,4) )));
//    $dir_list = gt_scandir( GT_DATA_DIR . 'cache/' );
/*
    for ( $i = count($dir_list)-1; $i>=0; $i--){
        $m_count = count(read_cache( 'all', $dir_list_w ));
    }
*/
/*
    $this_month_key = array_search($params['attributes']['value'], $dir_list );
            $smarty_month_navi->assign( 'this_month', 
                array( 'month'=>$dir_list[$this_month_key], 
                    'date'=> mktime(0,0,0,substr($dir_list[$this_month_key],4,2),1,
                            substr($dir_list[$this_month_key],0,4) )));
                            
    for( $i=1; isset($dir_list[$this_month_key+$i]); $i++){
        if ( count(read_cache( 'all', $dir_list[$this_month_key+$i])) > 0 ){
            $smarty_month_navi->assign( 'next_month', 
                array( 'month'=>$dir_list[$this_month_key+$i], 
                    'date'=> mktime(0,0,0,substr($dir_list[$this_month_key+$i],4,2),1,
                            substr($dir_list[$this_month_key+$i],0,4) )));
            break;
        }
    }
    for( $i=1; isset($dir_list[$this_month_key-$i]); $i++){
        if ( count(read_cache( 'all', $dir_list[$this_month_key-$i])) > 0 ){
            $smarty_month_navi->assign( 'previous_month', 
                array( 'month'=>$dir_list[$this_month_key-$i], 
                    'date'=> mktime(0,0,0,substr($dir_list[$this_month_key-$i],4,2),1,
                            substr($dir_list[$this_month_key-$i],0,4) )));
            break;
        }
    }
*/
}
?>