<div class="page_navi">
{insert name = "entry_navi" attributes=$attributes}
</div>

{foreach from=$entry item=e key=ek}
<div class="entry">

<DIV class="entry_title">{$e.title}</DIV>
{insert name=edit_entry entry=$ek}
<DIV class="entry_date">{$e.date|date_format:"%A, %B %e, %Y"}</DIV>
<div class="entry_text">
{$e.introduction}<a name="more"></a>
{$e.body}
</div>
<div style="clear:both;"></div>

<DIV class="entry_info">|
{$e.user_name}|
<A href="?c={$e.category_id}">{$e.category_name}</A>|{$e.date|date_format:"%H:%M"}|
{if $e.allow_comments or $e.comment|@count > 0}
<a href="#comment">コメント({$e.comment|@count})</a>|
{/if}
{if $e.allow_pings or $e.trackback|@count > 0}
<a href="#trackback">トラックバック({$e.trackback|@count})</a>|
{/if}
</DIV>
{***************************** コメント****** ********************}
<a name="comment"></a>
{foreach from=$e.comment item=c key=ck}
<a name="comment{$ck}"></a>
<div class="comment_title">コメント＃{$ck}</div>
<div class="comment_text">
{insert name=edit_comment entry=$ek comment=$ck}<br>
{$c.body|nl2br}
</div>
<DIV class="comment_info">

{if $c.url <> ""}
|<a href="{$c.url}">{$c.author}</a>|
{else}
|{$c.author}|
{/if}
{if $c.mail <> ""}{mailto address=$c.mail encode="javascript"}|{/if}
{$c.date|date_format:"%a,%b-%e %H:%M"}|</DIV>
{/foreach}

{*$cmt.comment_idは、コメント番号を指定した操作で、ログインが必要なのと同意*}
{if $e.allow_comments or $cmt.comment_id <> ''}
    <a name="do_comment"></a>
    {if $cmt.comment_id <> ''}
    <DIV class="entry_title">コメントの編集、削除</DIV>
    <br>
    <div class="comment_title">コメント＃{$cmt.comment_id}</div>
    <div class="comment_text">|{$cmt.ip}|{$cmt.host}|{$cmt.date|date_format:"%a,%b-%e %H:%M"}|<br>
    {$cmt.user_agent|default:"User-Agent is not specified"}<br>
    {$cmt.accept_language}</div>
    {else}
    <DIV class="entry_title">コメントする</DIV>
    {/if}

    <div class="comment_text">
    {foreach from=$comment_errors item=comment_error}
    <div style="color:red;">{$comment_error}</div>
    {/foreach}
    <FORM method="POST" action="index.php?do=comment#do_comment">
    {if $cmt.comment_id <> ''}
    <INPUT type="hidden" name="entry" value="{$cmt.entry_id}">
    <INPUT type="hidden" name="comment" value="{$cmt.comment_id}">
    {else}
    <INPUT type="hidden" name="entry" value="{$ek}">
    {/if}
    {if $protect_by_question and $cmt.comment_id == ''}
    {$comment.question_question}:
    <INPUT size="40" type="text" name="cmt[question_answer]" value="{$cmt.question_answer}"><BR>
    {/if}
    お名前：<br>
    <INPUT size="40" type="text" name="cmt[author]" value="{$cmt.author}"><BR>
    メール：<br>
    <INPUT size="40" type="text" name="cmt[mail]" value="{$cmt.mail}"><BR>
    ＵＲＬ：<br>
    <INPUT size="40" type="text" name="cmt[url]" value="{$cmt.url}"><BR>
    コメント：<BR>
    <TEXTAREA rows="10" cols="82" name="cmt[body]">{$cmt.body}</TEXTAREA><BR>
    {if $cmt.comment_id == ''}
        <INPUT type="submit" name="insert" value="コメントを送信する">
    {else}
        <INPUT type="submit" name="update" value="コメント更新">
        <INPUT type="submit" name="delete" value="コメント削除">
    {/if}
    </FORM>
    </div>
{/if}
{***************************** コメント終わり ********************}
{***************************** トラックバック ********************}
{if $e.allow_pings or $e.trackback|count > 0}
<a name="trackback"></a>
<DIV class="entry_title">トラックバック</DIV>
{if $e.allow_pings}
<DIV class="comment_text">
この記事へのトラックバックＵＲＬ： <br>
{trackback_url entry=$ek}
</DIV>
{else}
<DIV class="comment_text">
この記事へは、現在トラックバックはできません。
</DIV>
{/if}
{foreach from=$e.trackback item=t key=tk}
<a name="trackback{$tk}"></a>
<br>
<div class="comment_title">{$t.title|default:"無題"}</div>
<div class="comment_text">
{insert name=edit_trackback entry=$ek trackback=$tk}<br>
{$t.body|nl2br}
</div>
<DIV class="comment_info">

{if $t.blog_name == ''}
|<a href="{$t.url}">リンク</a>|
{else}
|<a href="{$t.url}">{$t.blog_name}</a>|
{/if}
{$t.date|date_format:"%a,%b-%e %H:%M"}|</DIV>
{foreachelse}
<div class="comment_text">
これまでに受信したトラックバックはありません。
</div>
{/foreach}
{/if}
{if $tb.trackback_id <> ''}
    <a name="do_trackback"></a>

    <DIV class="entry_title">トラックバックの編集、削除</DIV>

    <div class="comment_text">
    |{$tb.ip}|{$tb.host}|{$tb.date|date_format:"%a,%b-%e %H:%M"}|<br>
    {$tb.user_agent|default:"User-Agent is not specified"}<br>
    {$tb.accept_language}
    {foreach from=$trackback_errors item=trackback_error}
    <div style="color:red;">{$trackback_error}</div>
    {/foreach}
    <FORM method="POST" action="index.php?do=trackback#do_trackback">

    <INPUT type="hidden" name="entry" value="{$tb.entry_id}">
    <INPUT type="hidden" name="trackback" value="{$tb.trackback_id}">

    ブログ名：<br>
    <INPUT size="40" type="text" name="tb[blog_name]" value="{$tb.blog_name}"><BR>
    タイトル：<br>
    <INPUT size="40" type="text" name="tb[title]" value="{$tb.title}"><BR>
    ＵＲＬ：<br>
    <INPUT size="82" type="text" name="tb[url]" value="{$tb.url}"><BR>
    概要：<BR>
    <TEXTAREA rows="5" cols="82" name="tb[body]">{$tb.body}</TEXTAREA><BR>
        <INPUT type="submit" name="update" value="トラックバック更新">
        <INPUT type="submit" name="delete" value="トラックバック削除">
    </FORM>
    </div>

{/if}
{***************************** トラックバック終わり***************}
</div>
{include file='_rdf.tpl'}
{/foreach}
