<?php

require_once('./setup_admin.php');

$conf_file = GT_USER_CONF_FILE;
$template = 'edit_user.tpl';

$old_data_o = get_serial_data( $conf_file );

foreach ( $old_data_o as $k => $v ){
    check_convert_requested_data( $v, &$dummy, &$d_work, &$dummy_errors );
    $old_data[$k] = $d_work;
}

$request = $_REQUEST['s'];

$smarty = new smarty_c;
$smarty->assign( 'category_options', category_options() );

$smarty->assign( 'test', $old_data_o);
if ( isset( $_REQUEST['delete'] )){
        
    if ( !isset($old_data[$request['id']] ) ) {
        $errors[] = '削除しようとしたデータは存在しません。';
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }

    $outdata = $old_data;
    unset( $outdata[$request['id']] );

    $admin_exists = false;
    foreach ( $outdata as $v ){
        if ( $v['auth'] <> 1 ) continue;
        $admin_exists = true;
    }
    if ( !$admin_exists ){
        $errors[] = '管理ユーザーは最低１人必要です。';
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }

    update_serial_data( $conf_file, $outdata );
    header('Location: ' . $_SERVER['PHP_SELF'] . '?complete=1');
    exit;
} elseif ( isset( $_REQUEST['update'] )){
    $ret = check_convert_requested_data( $request, 
        $output, $display, $errors );
    if ( !$ret ) {
        $update_tochuu_data = $old_data;
        $update_tochuu_data[$output['id']]=$output;
        $smarty->assign( 'sl',$update_tochuu_data );
//        echo '<pre>';
//        print_r($old_data);
//        print_r($display);
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }
    elseif ( !isset($old_data[$request['id']] ) ) {
        $errors[] = '更新しようとしたデータは存在しません。';
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }else if ( $output == $old_data_o[$request['id']] ) {
        $errors[] = '旧データから、修正されていません。';
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    } else {
/*
        echo '<pre>';
        var_dump($output);
        var_dump($old_data_o[$request['id']]);
*/
    }
/*
    echo '<pre>';
    var_dump($output);
    var_dump($old_data[$request['id']]);
*/
    $outdata = $old_data_o;
    $outdata[$request['id']] = $output;

    $admin_exists = false;
    foreach ( $outdata as $v ){
        if ( $v['auth'] <> 1 ) continue;
        $admin_exists = true;
    }
    if ( !$admin_exists ){
        $errors[] = '管理ユーザーは最低１人必要です。';
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }
    update_serial_data( $conf_file, $outdata );
    header('Location: ' . $_SERVER['PHP_SELF'] . '?complete=1');
    exit;
}
elseif ( isset( $_REQUEST['insert'] )){

    $ret = check_convert_requested_data( $request, 
	$output, $display, $errors );

    if ( !$ret ) {
        $smarty->assign( 's',$display );
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
	} elseif ( isset($old_data[$display['id']]) ) {
        $errors[] = 'そのidは既に使用されています。';
        $smarty->assign( 's',$display );
        $smarty->assign( 'sl',$old_data );
        $smarty->assign( 'errors', $errors );
        $smarty->display($template);
        exit;
    }
    $outdata = $old_data;
    $outdata[$output['id']] = $output;
    update_serial_data( $conf_file, $outdata );
    header('Location: ' . $_SERVER['PHP_SELF'] . '?complete=1');
    exit;
} 
else {
    $smarty->assign( 'sl',$old_data );
    $smarty->display($template);
    exit;
}

function check_convert_requested_data( $input, &$output, &$display, &$errors ){
    $master_category = master_category();
    $ret = true;

    $display = $input;
    
    if ( $input['password'] <> $input['password2']  ) {
        $errors[] = 'パスワードと確認用パスワードが異なっています。';
        $ret = false;
    }
    if ( $input['id'] == '' ){
        $errors = 'idは必ず指定してください。';
        $ret = false;
    }
    if ( $input['moblog']['pop_host'] <> ''){
        if ( $input['moblog']['pop_password'] <> $input['moblog']['pop_password2']  ) {
            $errors[] = 'MOBLOG用パスワードと確認用パスワードが異なっています。';
            $ret = false;
        }
        if ( !isset( $master_category[$input['moblog']['category_id']] ) ){
            $errors[] = '登録されていないカテゴリが指定されました。';
            $ret = false;
        }
        if ( !ctype_digit( $input['moblog']['pop_access_interval'] )){
            $errors[] = 'POPアクセス間隔（分）は数字しか入力できません。';
            $ret = false;
        }
        require_once('pop3-class.php');
        $pop = new pop3( $input['moblog']['pop_host'],  $input['moblog']['pop_username'],
             $input['moblog']['pop_password'] );
        $retw = $pop->open();
        $pop->close();
        if ( !$retw ){
            $errors[] = 'POPメールサーバーに接続できませんでした。ホスト名、ユーザー名、パスワードを確認してください。';
            $ret = false;            
        }
    }

    array_walk_recursive( $display, 'array_specialchars' );    
    $output['id'] = $input['id'];
    $output['password'] = $input['password'];
    $output['password2'] = $input['password2'];
    $output['name'] = $input['name'];
    $output['smtp_host'] = $input['smtp_host'];
    $output['mail_address'] = $input['mail_address'];
    $output['auth'] = $input['auth'];
    $output['login_host_ip'] = $input['login_host_ip'];
    $output['login_host_name'] = $input['login_host_name'];
    $output['enable_bookmark_login'] = (bool) $input['enable_bookmark_login'];
    $output['bookmark_login_seed'] = $input['bookmark_login_seed'];
    $output['moblog']['pop_host'] = $input['moblog']['pop_host'];
    $output['moblog']['pop_username'] = $input['moblog']['pop_username'];
    $output['moblog']['pop_password'] = $input['moblog']['pop_password'];
    $output['moblog']['pop_password2'] = $input['moblog']['pop_password2'];
    $output['moblog']['category_id'] = $input['moblog']['category_id'];
    $output['moblog']['pop_access_interval'] = (int) $input['moblog']['pop_access_interval'];
    $output['moblog']['from_mail_address'] = $input['moblog']['from_mail_address'];
    $output['moblog']['align'] = $input['moblog']['align'];

    $master_blog = master_blog();
/*
    echo '**********<pre>';
    var_dump( $output);
    var_dump( $display);
    var_dump($ret);
    var_dump($errors);
    echo '**********';
*/
    if ( $output['enable_bookmark_login'])
    $display['bookmark_login_url'] = $master_blog['url'] . 'login.php?auto=' . 
        md5_autologin_param( $output['id'], $output['password'], $output['bookmark_login_seed']);
    return $ret;
}


?>
