<?php

require_once('gb_smtp.php');
/*
  戻り値：
	false:完全に失敗
	1:成功
	2:メール送信に失敗した受信者がいる（rcpt toでエラー発生）
*/
function gb_mail( $smtphost, $from_string, $from, $to, $subject, $body ) {

	$error_adr = array();
	$success_adr = array();
	$body = str_replace( "\r\n", "\n", $body);
	$body = str_replace( "\r", "\n", $body);
	$body = str_replace( "\n", "\r\n", $body);
	$body = str_replace( "\r\n.", "\r\n..", $body);
	if ( substr($body,0,1) == "." ) {
	    $arg = substr_replace( $body, "..", 0, 1 );
	}

	$rcpt = array();

	$rcpt[] = $to;

	$alldata  = '';
	$alldata .= 'Date: ' .date("D, j M Y G:i:s O (T)")."\r\n";
	$alldata .= 'Message-ID: <'.date("YmdHis").'gbmail@'.MYDOMAIN.">\r\n";
	$alldata .= "From: " . mb_encode_mimeheader2(mb_convert_encoding($from_string,'JIS','UTF-8'), 'ISO-2022-JP') . " <$from>\r\n";
	$alldata .= "To: " . $to . "\r\n";
	$alldata .= "Subject: " . mb_encode_mimeheader2(mb_convert_encoding($subject,'JIS','UTF-8'),'ISO-2022-JP') . "\r\n";

	$alldata .= $ad_header;
	$alldata .= "MIME-Version: 1.0\r\n";
	$alldata .= "Content-Type: text/plain; charset=iso-2022-jp\r\n";
	$alldata .= "Content-Transfer-Encoding: 7bit\r\n";
	$alldata .= "\r\n";
	$alldata .= mb_convert_encoding( $body, 'JIS','UTF-8');

    $ret_last = 1;

    $sock = gb_sockopen($smtphost);
    if (!$sock ) {
	return false;
    }
    $ret = gb_getresponse( $sock );
    if (!$ret ) {
	return false;
    }

    $ret = gb_putcmd( $sock, "HELO ". $_SERVER['HTTP_HOST']);
    if (!$ret ) {
	return false;
    }
    $ret = gb_getresponse( $sock );
    if (!$ret ) {
	return false;
    }

    $ret = gb_putcmd( $sock, "MAIL FROM:<".$from . ">");
    if (!$ret ) {
	return false;
    }
    $ret = gb_getresponse( $sock );
    if (!$ret ) {
	return false;
    }
//print_r($rcpt);

    foreach ( $rcpt as $r ) {
	$ret = gb_putcmd( $sock, "RCPT TO:<".$r.">");
	if (!$ret ) {
	    return false;
	}
	$ret = gb_getresponse($sock, true);
	if (!$ret ) {
	    return false;
	} elseif ( $ret == 2 ) {
//	echo 'errror'.$r;
	    $error_adr[] = $r;
	    $ret_last = 2;
	} else {
//	echo 'success'.$r;
	    $rcpt_success = true;
	    $success_adr[] = $r;
	}
    }

    if ( !$rcpt_success ) {
    } else {
	$ret = gb_putcmd( $sock, "DATA");
	if (!$ret ) {
	    return false;
	}
	$ret = gb_getresponse( $sock );
	if (!$ret ) {
	    return false;
	}

	$ret = gb_senddata( $sock, $alldata );
	if (!$ret ) {
	    return false;
	}
	$ret = gb_getresponse( $sock );
	if (!$ret ) {
	    return false;
	}
    }
    $ret = gb_putcmd( $sock, "QUIT");
    if (!$ret ) {
	return $ret_last;
    }
    $ret = gb_getresponse( $sock );
    if (!$ret ) {
	return $ret_last;
    }

    gb_sockclose( $sock );


    return $ret_last;

}
function mb_encode_mimeheader2($string, $encoding = "ISO-2022-JP") {
    $ret_string = '';
    $ret_string .= '=?'.$encoding.'?B?';
    $ret_string .= base64_encode( $string );
    $ret_string .= '?=';
    return $ret_string;
}
?>
