<?php
function image_save( $in_file_name, $out_file_name,
    $s, $retim, $o_im, &$file, &$errors ){
    list($width, $height, $type, $attr) = $retim;
    $master_upload=master_upload();
//echo '************';
    if ( !$s ) $s = $master_upload;

    $out_base =  preg_replace( '/\.[^\.]*$/', '', $out_file_name );
    preg_match( '/\.[^\.]*$/', $out_file_name, $m );
    $orig_dot_type = $m[0];
    for( $i = 0; true; $i++ ){
        $exists = false;
        foreach (  array('original','popup','standard','thumbnail' ) as $k ) {
            if ( $i == 0 ){
                $out_base_w = $out_base;
            } else {
                $out_base_w = $out_base . '_' . $i;
            }
            $f = glob( $master_upload[$k]['path'] . '/' . $out_base_w . '.*' );
//            echo $master_upload[$k]['path'] . '/' . $out_base_w . '.*';
            if ( count($f) > 0 ){
                $exists = true;
                break;
            }
        }
        if ( !$exists ) break;
    }
//    echo 'out_name = ' . $out_name;
    foreach ( array('original','popup','standard','thumbnail' ) as $k ){
        if ( $s[$k]['save_option'] === 'no' ) continue;
        elseif ( $s[$k]['save_option'] === 'if' ){
            if ( $k == 'popup' ){
                if ( $s['standard']['width'] >= $width and
                     $s['standard']['height'] >= $height ){
                    continue;
                }
            }
        }
        if ( $k == 'original' or
             ($s[$k]['convert_option'] == 'no' or
              ( $s[$k]['convert_option' ] == 'if' and
                $s[$k]['width'] >= $width and $s[$k]['height'] >= $height ) ) ){
//               print_r($s[$k]);
//            $ret = copy( $_FILES['userfile']['tmp_name'], $s[$k]['path'] . '/' . 
//                        $_FILES['userfile']['name'] );
            $ret = copy( $in_file_name, $s[$k]['path'] . '/' . 
                        $out_base_w . $orig_dot_type );
            if ( !$ret ){
                $errors[]='t@C??B';
                return false;
            }
        } else {
//            echo "$k convert\n";
            if ( $width / $s[$k]['width'] > $height / $s[$k]['height'] ){
                $new_width = $s[$k]['width'];
                $new_height = round( $height * $s[$k]['width'] / $width );
            } else {
                $new_height = $s[$k]['height'];
                $new_width = round( $width * $s[$k]['height'] / $height );
            }
            
            if ( $retim['mime'] == 'image/jpeg' ) {
                $t_im = imageCreateTrueColor($new_width,$new_height);
                imageCopyResampled($t_im, $o_im, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
                imageJPEG($t_im,  $s[$k]['path'] . '/' . 
                        $out_base_w . '.jpg' , $s[$k]['quality']);
            } elseif ( $retim['mime'] == 'image/gif' ){
                $t_im = imageCreate($new_width,$new_height);
                imageCopyResampled($t_im, $o_im, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
                imageGIF($t_im,  $s[$k]['path'] . '/' . 
                        $out_base_w .'.gif');
            }
        }
    }
    $file = $out_base_w;
//    $file = $_FILES['userfile']['name'];
    return true;
}

function image_read( &$retim, $o_file, &$o_im, &$errors ){

    $retim = getimagesize( $o_file );
    if ( !$retim ){
        $errors[] = 'その形式はサポートしていません。';
        return false;
    }
    switch ( $retim['mime'] ){
       case 'image/gif':
           if (imagetypes() & IMG_GIF)  { // not the same as IMAGETYPE
               $o_im = imageCreateFromGIF($o_file) ;
           } else {
               $errors[] = 'GIFは本PHP構成ではサポートしてません。';
               return false;
           }
           break;
       case 'image/jpeg':
           if (imagetypes() & IMG_JPG)  {
               $o_im = imageCreateFromJPEG($o_file) ;
           } else {
               $errors[] = 'JPGは本PHP構成ではサポートしてません';
               return false;
           }
           break;
       case 'image/png':
           if (imagetypes() & IMG_PNG)  {
               $o_im = imageCreateFromPNG($o_file) ;
           } else {
               $errors[] = 'PNGは本PHP構成ではサポートしてません';
               return false;
           }
           break;
       case 'image/wbmp':
           if (imagetypes() & IMG_WBMP)  {
               $o_im = imageCreateFromWBMP($o_file) ;
           } else {
               $errors[] = 'WBMPは本PHP構成ではサポートしてません';
               return false;
           }
           break;
       default:
           $errors[] = $retim['mime'].'は本システムでサポートされていません。';
           return false;
           break;
    }
    return true;
}
?>