<?php
/*
    usage {insert name="entry_navi" attributes=$attributes}
*/

function smarty_insert_entry_navi( $params, &$smarty ){
    $smarty_entry_navi = new smarty_c;

    $smarty_entry_navi->caching = 2;
    $smarty_entry_navi->cache_lifetime = -1;
    if ( isset($_REQUEST['c']) ) $c = $_REQUEST['c'];
    else $c = 'all';
//    print_r($params);
    $smarty_entry_navi_cache_id = 'entry_navi|' . $c . '|' .
        $params['attributes']['value'] . '|' . which_view();
//    print_r( $params );
    if ( !$smarty_entry_navi->is_cached('entry_navi.tpl', $smarty_entry_navi_cache_id) ) {
//        echo 'generated';
        $ret = process_entry_navi( $smarty_entry_navi, $params, $c);
        if (!$ret ) return false;
    }
   
    return $smarty_entry_navi->fetch('entry_navi.tpl', $smarty_entry_navi_cache_id );
}
function process_entry_navi( &$smarty_entry_navi, $params, $c){
    $master_blog = master_blog();
    $master_category = master_category();
    $smarty_entry_navi->assign( 'blog', $master_blog );
    $smarty_entry_navi->assign( 'attributes', $params['attributes'] );

    if ( $c <> 'all' ) {
        $cname = $master_category[$c]['name'];
        if ( !$cname ) {
            return false;
        } else {
            $params['attributes']['category_id'] = $c;
            $params['attributes']['category_name'] = $cname;
        }
    } else {
        $params['attributes']['category_id'] = 'all';
        $params['attributes']['category_name'] = '';
    }
    $cache = read_cache($c);

    $this_entry_key = array_search($params['attributes']['value'], $cache );

    $smarty_entry_navi->assign( 'attributes', $params['attributes'] );
//echo '*******************';
//    print_r($params['attributes']);
    $next_entry_number = $cache[$this_entry_key+1];
    if ( $next_entry_number !== NULL ){
        $next_entry[$next_entry_number] = get_entry( $next_entry_number );
        array_walk_recursive( $next_entry, 'array_specialchars' );
        $smarty_entry_navi->assign( 'next_entry', $next_entry );
    }
    $previous_entry_number = $cache[$this_entry_key-1];
    if ( $previous_entry_number !== NULL ){
        $previous_entry[$previous_entry_number] = get_entry( $previous_entry_number );
        array_walk_recursive( $previous_entry, 'array_specialchars' );
        $smarty_entry_navi->assign( 'previous_entry', $previous_entry );
    }
    return true;
}
?>