<?php
/*
    usage {login
                p=xxxx  → テンプレートに渡すパラメータを指定。キャッシュのＩＤにもなる。
*/

function smarty_insert_login( $params, &$smarty ){

    require_once('login_func.php');
    $smarty_login = new smarty_c;

    $p = $params['p'];
    $gb_login_info = gb_login_info();

    //ログインしている場合にはキャッシュしない。
    if ( $gb_login_info ){
        process_login( $smarty_login, $params );
        $smarty_login->caching = 0;
        $smarty_login->assign( 'gb_login', gb_login_info());
        $smarty_login->assign( 'p', $p );
        return $smarty_login->fetch('login.tpl');
    //ログインしていない場合には、無期限でキャッシュする。
    } else {
        $smarty_login->caching = 2;
        $smarty_login->cache_lifetime = -1;
        $smarty_login->assign( 'p', $p );
        $smarty_login_cache_id = 'login|nologin|' .$p. '|'. which_view();
        return $smarty_login->fetch('login.tpl', $smarty_login_cache_id );
    }
}
function process_login( &$smarty_login, $params ){
    $cache = read_cache_draft();
//    print_r($cache);
    $entry_number = end($cache);
    for ( $i = 0; $entry_number !== false; $i++ ){
        $draft_entry[$entry_number] = get_entry( $entry_number );
        $entry_number = prev($cache);
    }
//    print_r($draft_entry);
    $smarty_login->assign( 'draft_entry', $draft_entry );
}
?>