<?php
/*
    usage {insert_months  max=5}  ftHg5
               
*/

function smarty_insert_months( $params, &$smarty ){

    if ( !isset($params['max']) ) $params['max'] = 5;

    $smarty_months = new smarty_c;
    $smarty_months_cache_id = 'months|' . which_view();
//echo $smarty_months_cache_id;
    $smarty_months->caching = 2;
    $smarty_months->cache_lifetime = -1; 
    if ( !$smarty_months->is_cached( 'months.tpl', $smarty_months_cache_id ) ) {
        process_months( $smarty_months, $params );
    }
    return $smarty_months->fetch('months.tpl', $smarty_months_cache_id );
}
function process_months( &$smarty_months, $params ){
    $dir_list = gt_scandir( GT_DATA_DIR . 'cache/' );
    
    $m_d_count = 0;
    for ( $i = count($dir_list)-1; $i>=0 and $m_d_count < $params['max']; $i--){
//        $m_count = count(read_cache_month( $dir_list[$i] ));
        $m_count = count(read_cache( 'all', $dir_list[$i] ));

        if ( $m_count > 0 ){
            $m_d_count++;
            $archive_month[$dir_list[$i]] = array(
                'date'=>mktime(0,0,0,substr($dir_list[$i],4,2),1,substr($dir_list[$i],0,4)),
                'count'=>$m_count );
        }
    }
    
    $smarty_months->assign( 'month_archive', $archive_month );
}
?>