<?php
/*
    usage {insert name="page_navi" attributes={$attributes}}
*/

function smarty_insert_page_navi( $params, &$smarty ){

//    var_dump( $params );
//    exit;
    $smarty_page_navi = new smarty_c;

    $smarty_page_navi->caching = 2;
    $smarty_page_navi->cache_lifetime = -1;
    $smarty_page_navi_cache_id = 'page_navi|' . $params['attributes']['category_id'] . '|' .
        $params['attributes']['value'] . '|' . which_view();
    if ( !$smarty_page_navi->is_cached('page_navi.tpl', $smarty_page_navi_cache_id ) ) 
        process_page_navi( $smarty_page_navi, $params);
    return $smarty_page_navi->fetch('page_navi.tpl', $smarty_page_navi_cache_id );
}
function process_page_navi( &$smarty_page_navi, $params ){
    $master_blog = master_blog();
    $smarty_page_navi->assign( 'blog', $master_blog );
    $cache = read_cache( $params['attributes']['category_id'] );

    $last_page_number = count_to_last_page_number ( count($cache), which_view() );
/*
    $last_entry_number = count($cache) - 1;
    if ( $last_entry_number <  $master_blog[$params['attributes']['view']]['top_page_count'] ){
        $last_page_number = -1;
    } else {
        $last_page_number =
                (int) ( ( $last_entry_number -  
                            $master_blog[$params['attributes']['view']]['top_page_count']
                           ) /
                           $master_blog[$params['attributes']['view']]['past_page_count'] 
                      );
    }
*/
//    for( $i=0; $i<= $last_page_number; $i++ ) $page_list[] = $i;
    for( $i=1; $i<= $last_page_number; $i++ ) $page_list[] = $i;

    $previous_page = array();
//    if ( $params['attributes']['value'] === 'last' and $last_page_number >= 0 ){
    if ( $params['attributes']['value'] === 'last' and $last_page_number > 0 ){
        $previous_page[$last_page_number] = array();
//    } elseif ( $params['attributes']['value'] > 0 ) {
//        $previous_page[$params['attributes']['value'] - 1] = array();
    } elseif ( $params['attributes']['value'] > 1 ) {
        $previous_page[$params['attributes']['value'] - 1] = array();
    }
    $smarty_page_navi->assign( 'previous_page', $previous_page );
//    print_r($previous_page);
    if ( $params['attributes']['value'] === $last_page_number ){
        $next_page['last'] = array();
    } elseif ( $params['attributes']['value'] !== 'last' and $last_page_number >= 0 ) {
        $next_page[$params['attributes']['value'] + 1] = array();
    }
//    print_r($next_page);
    $smarty_page_navi->assign( 'next_page',  $next_page  );
    $smarty_page_navi->assign( 'attributes', $params['attributes'] );
    $smarty_page_navi->assign( 'page_list', $page_list );
}
?>