<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
<HEAD>
<TITLE></TITLE>
</HEAD>
<BODY>
<H1 align="left">説明</H1>
<H2>１．メニューの説明</H2>
<P>とりあえず、それぞれのメニューをクリックすると説明がありますが、以下の２つだけはいきなり実行されます。
なので説明しておきます。</P>
<H3>１．１　データキャッシュ再構築</H3>
<P>データキャッシュファイルの再構築をします。必ず実行するのは以下の場合です。</P>
<ul>
<li>導入直後</li>
<li>インポートした直後</li>
</ul>
<P>マシンがクラッシュしたり、プログラムになにかあった場合の後にも実行しなければならない可能性があります。</P>
<P>キャッシュのディレクトリは２つあります。</P>
<UL>
  <LI>data/cache: 月ごと、カテゴリごとのエントリ番号を保持している。
  <LI>data/cache_s: （これを書いている時点で、）非公開エントリのエントリ番号を保持している。
</UL>
<H3>１．２　smartyキャッシュ全クリア</H3>
<P>ログインしていないユーザーにみせてもよいコンテンツは、smartyのキャッシュ機能を使用してキャッシュされています。通常エントリの追加や変更をした場合等は、自動的に必要なキャッシュがクリアされます。</P>
<P>以下の場合、キャッシュを手動でクリアする必要があります。</P>
<UL>
  <LI>過去のエントリが参照している画像を編集し、画像のサイズを変更したり、popupを削除、追加したとき。imageタグは、画像を見て生成されているので、キャッシュされているＨＴＭＬは修正されません。
  <LI>ブログの設定、カテゴリ設定、ユーザー設定、トラックバック受信設定で、ユーザーの見る画面に影響する項目を修正したとき。ただし、do=comment,
  do=listtrackbackなどの画面は、常に動的に生成されているので、キャッシュはされていません。
  <LI>データキャッシュ再構築をおこなった時。
</UL>
<H2>２．環境設定について</H2>
<P>現時点では、gakibloは、自分でサーバーの環境構築をする人限定、となっています。レンタルサーバーの制約の中で動くようにはなってないと思います。（奇特な方、誰かチャレンジしてみませんか？）<BR>
で、gakibloを正しく動作させるのに影響するパラメータを挙げておきます。これ以外にもあるかもしれませんが、、、<BR>
</P>
<TABLE border="1">
  <TBODY>
    <TR>
      <TD colspan="3">OS, Network</TD>
    </TR>
    <TR>
      <TD width="184">パラメータ等</TD>
      <TD width="17">推奨値</TD>
      <TD>説明</TD>
    </TR>
    <TR>
      <TD width="184">OS</TD>
      <TD width="17"></TD>
      <TD>UNIX系じゃないと、動かないかも、、、一応プログラミングでは、UNIX系オンリーの関数当は使ってないつもり（ロックは、、、）。でも、ぜんぜん試してません。求む人柱！</TD>
    </TR>
    <TR>
      <TD width="184">IPアドレスの逆引き</TD>
      <TD width="17">可能なこと</TD>
      <TD>いろいろと、ご批判はあるかもしれませんが、随所でやってます。</TD>
    </TR>
    <TR>
      <TD colspan="3">Apache</TD>
    </TR>
    <TR>
      <TD width="184">パラメータ</TD>
      <TD width="17">推奨値</TD>
      <TD>説明</TD>
    </TR>
    <TR>
      <TD width="184">AddDefaultCharset</TD>
      <TD width="17">UTF-8</TD>
      <TD>デフォルトの応答Charsetを設定します。環境によっては、必要ないと思います。</TD>
    </TR>
    <TR>
      <TD width="184">AllowOverride</TD>
      <TD width="17">All</TD>
      <TD>インストールパッケージでは、.htaccessにいろいろと設定をしています。これが許されない場合は、、、個別に考えてね。とりあえず、Deny
      from allと書いてあるディレクトリの扱いは、セキュリティ上気をつけたほうがいいかも。</TD>
    </TR>
    <TR>
      <TD width="184">MPM</TD>
      <TD width="17">prefork</TD>
      <TD>ファイルのロックの仕組みを使っちゃいました。<BR>
      １プロセスマルチスレッドのような環境では、ロックがうまくいきません。<BR>
      ( httpd -lで、どのＭＰＭを使用しているかが確認できます。）</TD>
    </TR>
    <TR>
      <TD colspan="3">PHPコンパイルオプション</TD>
    </TR>
    <TR>
      <TD width="184">パラメータ</TD>
      <TD width="17">推奨値</TD>
      <TD>説明</TD>
    </TR>
    <TR>
      <TD width="184">--with-gd</TD>
      <TD width="17"></TD>
      <TD>画像をアップロードするだけで、必須になっちゃってます。</TD>
    </TR>
    <TR>
      <TD width="184">--with-mbstring</TD>
      <TD width="17"></TD>
      <TD>これは、絶対必須。</TD>
    </TR>
    <TR>
      <TD colspan="3">php.ini ディレクティブ（.htaccessで設定はしています、、、）</TD>
    </TR>
    <TR>
      <TD width="184">magic_quotes_gpc</TD>
      <TD width="17">0</TD>
      <TD>現状、入力値がそのまま来ることが前提です。（ちなみに、1の場合、なぜか、smartyから、エラーがちょこちょこ忘れた頃に出ます。原因不明だけど、、、）</TD>
    </TR>
    <TR>
      <TD width="184">default_charset</TD>
      <TD width="17">UTF-8</TD>
      <TD rowspan="8">これらは、設定しなくても大丈夫なもの、設定しなくても、他のを設定すれば大丈夫なもの、等、いろいろです。<BR>
      問い合わせをする場合は、「推奨値にしても駄目だった。」等、言ってもらえたほうが、対応しやすいと思います。<BR>
      要は、「プログラムは、ＵＴＦ－８で書いている。内部文字エンコーディングは、ＵＴＦ－８が大前提。入出力のデータはプログラムでコード変換している場合がある、出力のヘッダは、プログラム内で操作している場合がある。」ということですので、これに注意して、適宜、カスタマイズしてもらえればと思います。</TD>
    </TR>
    <TR>
      <TD width="184">output_handler</TD>
      <TD width="17">NULL</TD>
    </TR>
    <TR>
      <TD>ｍｂｓｔring.language</TD>
      <TD>neutral</TD>
    </TR>
    <TR>
      <TD width="184">mbstring.http_input</TD>
      <TD width="17">UTF-8</TD>
    </TR>
    <TR>
      <TD width="184">mbstring.http_output</TD>
      <TD width="17">UTF-8</TD>
    </TR>
    <TR>
      <TD width="184">mbstring.script_encoding</TD>
      <TD width="17">UTF-8</TD>
    </TR>
    <TR>
      <TD>mbstring.internal_encoding</TD>
      <TD>UTF-8</TD>
    </TR>
    <TR>
      <TD>mbstring.encoding_translation</TD>
      <TD>0</TD>
    </TR>
    <TR>
      <TD>display_errors</TD>
      <TD></TD>
      <TD>好きに設定してください。管理画面のディレクトリでは、１にしたほうがいいかも。
</TD>
    </TR>
    <TR>
      <TD>log_errors</TD>
      <TD></TD>
      <TD rowspan="2">好きに設定してもらってかまいませんが、問い合わせする前には、ログは確認してください。</TD>
    </TR>
    <TR>
      <TD>error_log</TD>
      <TD></TD>
    </TR>
  </TBODY>
</TABLE>

</BODY>
</HTML>